﻿Imports System.Threading

Public Class Form1

    'DLL函数声明
    '工程默认为32bit(x86)项目，如需适配64bit(x64)，可在工程属性Target CPU中改为x64，并把DLL的引用名改为"MPS Driver_x64"即可
    Private Declare Function MPS_OpenDevice Lib "MPS Driver.dll" (ByVal DeviceNumber As Int32) As Int32
    Private Declare Function MPS_CloseDevice Lib "MPS Driver.dll" (ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_GetDeviceID Lib "MPS Driver.dll" (ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_Start Lib "MPS Driver.dll" (ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_Stop Lib "MPS Driver.dll" (ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_Configure Lib "MPS Driver.dll" (ByVal SampleRate As Int32, ByVal DIOMode As Int32, ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_DataIn Lib "MPS Driver.dll" (ByRef DataArray As Int32, ByVal SampleNumber As Int32, ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_TimeOut Lib "MPS Driver.dll" (ByVal TimeOut_ms As Int32, ByVal DeviceHandle As Int32) As Int32

    Private Declare Function MPS_GetDeviceDescriptor Lib "MPS Driver.dll" (ByVal Descriptor As String, ByVal StringLength As Int32, ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_GetDeviceInformation Lib "MPS Driver.dll" (ByVal Information As String, ByVal StringLength As Int32, ByVal DeviceHandle As Int32) As Int32
    Private Declare Function MPS_SetUserInformation Lib "MPS Driver.dll" (ByVal UserInformation As String, ByVal StringLength As Int32, ByVal DeviceHandle As Int32) As Int32

    Private Declare Function MPS_ResetDevice Lib "MPS Driver.dll" (ByVal DeviceHandle As Int32) As Int32

    '与硬件驱动相关的变量
    Dim CH As Int32                              '板卡的通道个数
    Dim Stat As Int32                            '函数返回状态标志
    Dim DeviceNumber As Int32                    '设备序号
    Dim DeviceHandle As Int32                    '设备句柄
    Dim DAQTime As Double                        '采集时间
    Dim SamlpleRate As Int32                     '采样率
    Dim SampleNumber As Int32                    '采样样点个数
    Dim PreAcquisitionSampleNumber As Int32      '预采集样点个数
    Dim DataArray(1000000) As Int32              '缓存原始采样数据的数组
    Dim VoltageRange As Double                   '电压量程


    '读写信息相关的变量
    Dim Descriptor As String '* 64               '设备型号字符串
    Dim Information As String '* 2048            '设备信息字符串
    Dim UserInformation As String '* 500         '用户自定义信息字符串

    '数据处理相关的变量
    Dim VoltageArray(1000000) As Double         '缓存处理后的电压数据的数组
    Dim MaxYScale As Double                     'Y轴显示范围
    Dim LineWidth As Int32                      '绘制波形使用的线宽
    Dim Colors(16) As Pen                       '不同通道绘制曲线的颜色




    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        '初始化采样参数
        DAQTime = 0.1                           '采样时间初始化默认值0.1s
        MaxYScale = 5                           'Y轴默认显示范围为正负5V范围

        '初始化绘图参数
        LineWidth = 2                           '绘图线宽
        Colors = {New Pen(Color.LightSkyBlue, LineWidth), New Pen(Color.Red, LineWidth), New Pen(Color.OliveDrab, LineWidth), New Pen(Color.DimGray, LineWidth), New Pen(Color.Blue, LineWidth), New Pen(Color.Violet, LineWidth), New Pen(Color.Green, LineWidth), New Pen(Color.Black, LineWidth), New Pen(Color.CornflowerBlue, LineWidth), New Pen(Color.Magenta, LineWidth), New Pen(Color.Chartreuse, LineWidth), New Pen(Color.LightSlateGray, LineWidth), New Pen(Color.MidnightBlue, LineWidth), New Pen(Color.MediumVioletRed, LineWidth), New Pen(Color.DarkOliveGreen, LineWidth), New Pen(Color.DarkGray, LineWidth)}
        '曲线颜色

        '初始化Timer
        Timer1.Interval = 10                        '调用采集与显示函数的时间间隔
        Timer1.Start()
        Timer1.Enabled = False

    End Sub

    Private Sub GetInformation_Click(sender As Object, e As EventArgs) Handles GetInformation.Click

        '获取设备硬件信息
        Dim StringBuffer(2048) As Byte              '
        Dim i As Int32
        For i = 0 To 2048 - 1
            StringBuffer(i) = 1
        Next i
        Information = System.Text.Encoding.Unicode.GetString(StringBuffer, 0, 2048)     '为Information准备2048长度的缓存空间


        DeviceHandle = MPS_OpenDevice(DeviceNumber) '打开设备
        If DeviceHandle = -1 Then                   '若打开失败，弹出报错对话框
            MsgBox("未检测到硬件，请检查设备连接！")
        End If


        Stat = MPS_GetDeviceInformation(Information, 2048, DeviceHandle) '获取设备硬件信息

        MsgBox(Information)                         '显示硬件信息

        Stat = MPS_CloseDevice(DeviceHandle)        '关闭设备
    End Sub



    Private Sub SesUserInformation_Click(sender As Object, e As EventArgs) Handles SesUserInformation.Click

        '写入用户自定义信息
        Dim StringBuffer(500) As Byte
        Dim i As Int32
        For i = 0 To 500 - 1
            StringBuffer(i) = 1
        Next i
        Information = System.Text.Encoding.Unicode.GetString(StringBuffer, 0, 500)      '为Information准备2048长度的缓存空间

        DeviceHandle = MPS_OpenDevice(DeviceNumber) '打开设备
        If DeviceHandle = -1 Then                   '若打开失败，弹出报错对话框
            MsgBox("未检测到硬件，请检查设备连接！")
        End If

        UserInformation = "Thie is a VB test."      '自定义信息

        Stat = MPS_SetUserInformation(UserInformation, 500, DeviceHandle) '写入用户自定义信息

        MsgBox("The information  '" + UserInformation + "'   has been written!")    '显示写入成功

        Stat = MPS_CloseDevice(DeviceHandle)        '关闭设备
    End Sub



    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        '数据采集
        Dim TimerBackup As Boolean                  '停止Timer并保存当前Timer状态
        TimerBackup = Timer1.Enabled
        Timer1.Enabled = False

        DeviceNumber = 0                            '设备0

        DeviceHandle = MPS_OpenDevice(DeviceNumber) '打开设备
        If DeviceHandle = -1 Then                   '若打开失败，弹出报错对话框
            MsgBox("未检测到硬件，请检查设备连接！")
            TimerBackup = False                     '停止定时器，暂停采集
        End If

        '获取设备型号，确定通道个数
        Dim StringBuffer(64) As Byte                '为Descriptor准备64长度的缓存空间
        Dim i As Int32
        For i = 0 To 64 - 1
            StringBuffer(i) = 1
        Next i
        Descriptor = System.Text.Encoding.Unicode.GetString(StringBuffer, 0, 64)
        Stat = MPS_GetDeviceDescriptor(Descriptor, 64, DeviceHandle) '获取设备型号信息

        CH = 4                                      'CH初始化为4通道
        Descriptor = Descriptor.Substring(0, 10)    '截取设备型号的前10个字符进行比对

        If Descriptor(9) = "2" Then                 '判断通道个数，根据型号的最后一位来判断通道个数，最后一位为2时通道数为2，最后一位为4时通道数为4，最后一位为8时通道数为8，最后一位为6（即16）时通道数为16；例如型号为MPS-HD2404，最后一位为4，此时通道数为4。
            CH = 2
        End If

        If Descriptor(9) = "4" Then
            CH = 4
        End If

        If Descriptor(9) = "8" Then
            CH = 8
        End If

        If Descriptor(9) = "6" Then
            CH = 16
        End If

        VoltageRange = 5.16                         '设定量程参数，MPS-HD2404、MPS-2408、MPS-HD2416、MPS-HD1608、MPS-HD1616等量程为5.16V；MPS-HD1604量程为5.2V；MPS-HD1802量程为5.3V；


        PreAcquisitionSampleNumber = 256            '有效采集前预采集的样点数，用于清空缓冲区，消除间断采集中未读数时产生的无效数据
        SampleNumber = (SamlpleRate * DAQTime * CH) / 128 * 128     '计算准备采集的样点数
        If SampleNumber = 0 Then
            SampleNumber = 128
        End If


        SamlpleRate = 64000                         '64K采样率

        Stat = MPS_Configure(SamlpleRate, 0, DeviceHandle)  '设置采样率和DIO，DIOMode = 0为闲置，DIOMode= 1为输出5V，DIOMode = 2为外部启动模式

        Stat = MPS_TimeOut(5000, DeviceHandle)         '设置超时。TimeOut_ms = 0不启用超时。如果是在正常采集中加入超时，建议TimeOut_ms设置为5000ms（但必须要大于DataIn实际采集需要的时长）；如果是在外部启动模式下加入超时，TimeOut_ms应大于实际外部启动信号到来的最长等待时间，且TimeOut_ms最大取值为100000ms

        Stat = MPS_Start(DeviceHandle)              '启动采集。如果是使用外部启动模式，则不执行此命令

        Stat = MPS_DataIn(DataArray(0), PreAcquisitionSampleNumber + SampleNumber, DeviceHandle) '读取数据

        Stat = MPS_Stop(DeviceHandle)               '停止采集

        Stat = MPS_CloseDevice(DeviceHandle)        '关闭设备



        For i = 0 To SampleNumber / CH - 1          '数据处理，计算电压值
            For j = 0 To (CH - 1)
                VoltageArray(i * CH + j) = (DataArray(PreAcquisitionSampleNumber + i * CH + j) / 65536 / 128) * VoltageRange  '计算电压
            Next j
        Next i


        '波形显示准备
        Dim WaveChart As New Bitmap(PictureBox1.Width, PictureBox1.Height)          '波形图初始化
        Dim graph As Drawing.Graphics = Drawing.Graphics.FromImage(WaveChart)
        PictureBox1.Image = WaveChart

        Dim Xinterval As Int32                                                      '计算波形显示时的抽点间隔
        Xinterval = 1
        Do While PictureBox1.Width * Xinterval < SampleNumber / CH
            Xinterval += 1
        Loop
        Xinterval -= 1

        Dim Yinterval As Double = MaxYScale * 2 / PictureBox1.Height                '计算Y轴缩放比例
        Dim Yoffset As Int32 = PictureBox1.Height / 2


        '显示波形
        Dim Point As Int32
        Dim PointNext As Int32
        For i = 0 To (CH - 1)                       '不同通道的波形用不同的颜色绘制
            For j = 0 To PictureBox1.Width
                Point = VoltageArray(j * CH * Xinterval + i) / Yinterval + Yoffset
                PointNext = VoltageArray((j + 1) * CH * Xinterval + i) / Yinterval + Yoffset
                graph.DrawLine(Colors(i), j, Point, j + 1, PointNext)
            Next j
        Next i


        Timer1.Enabled = TimerBackup                '恢复定时器

    End Sub


    Private Sub SetYScale_Click(sender As Object, e As EventArgs) Handles SetYScale.Click
        '设置Y轴显示范围
        Dim YScaleValue = Val(YScale.Text)
        If YScaleValue > 0 Then
            If YScaleValue < 5 Then
                MaxYScale = YScaleValue
            End If
        End If

    End Sub


    Private Sub SetTimeLength_Click(sender As Object, e As EventArgs) Handles SetTimeLength.Click
        '设置每帧波形对应的采样时间
        Dim TimeLengthVlue = Val(TimeLength.Text)
        If TimeLengthVlue > 0 Then
            If TimeLengthVlue <= 2 Then
                DAQTime = TimeLengthVlue
            End If
        End If

    End Sub


    Private Sub Acquisition_Click(sender As Object, e As EventArgs) Handles Acquisition.Click
        '开始与停止采集
        If Timer1.Enabled = True Then
            Timer1.Enabled = False
        Else
            Timer1.Enabled = True
        End If
    End Sub
End Class
